program arbres;

type tree = Empty | Node of tree * integer * tree;
     enum = End_ | More of integer * tree * enum;

var
   t :  tree;

function max(x,y : integer) : integer;
begin
   if x >= y then max := x else max := y
end;

function hauteur(t : tree) : integer;
begin
   case t of
     Empty : hauteur := 1
   | Node(l,_,r): hauteur := 1 + max(hauteur(l), hauteur(r));
   end; { case }
end;

procedure infixe(t :  tree);
begin
   case t of
     Empty :
   | Node(l,x,r): infixe(l); writeln(x); infixe(r);
   end;
end; { infixe }

function cons_enum(t : tree; e : enum) : enum;
begin
   case t of
     Empty : cons_enum := e;
     | Node(l,x,r): cons_enum := cons_enum(l,More(x,r,e));
   end
end; { cons_enum }

function start(t : tree) : enum;
begin start := cons_enum(t, End_); end;

procedure traverse(e :  enum);
begin
   case e of
     End_:
   | More(x,r,e1): writeln(x); traverse(cons_enum(r,e1));
   end;
end;

begin
   t := Node(Node(Empty, 1, Empty),
	     2,
	     Node(Node(Empty, 3, Empty), 4, Empty));
   infixe(t);
   writeln(hauteur(t));
   traverse(start(t));
end.

	     